__author__ = 'intigua'

import subprocess
import os
import os

def quitecall(cmd):
    with open(os.devnull, 'w') as f:
        return subprocess.Popen(cmd, stdout=f, stderr=f).wait()

class Ssh(object):
    def __init__(self, remote, quite = False):
        self.remote = remote
        self.quite = quite

    def run(self, cmd):
        if isinstance(cmd, str):
            cmd = [cmd]
        cmd = ["ssh", "-o", "BatchMode yes", self.remote] + cmd
        if self.quite:
            return quitecall(cmd)
        else:
            return subprocess.call(cmd)

def file_exists(remote, path):
    if remote:
        return 0 == Ssh(remote, quite=True).run(["ls" , path])
    else:
        return os.path.exists(path)

def check_install_profile(remote):
    src_exists = lambda p: file_exists(remote, p)
    intigua_exists = src_exists("/usr/share/intigua")
    tocmat_exists = src_exists("/usr/share/tomcat")
    nginx_exists = src_exists("/usr/share/nginx")
    tomcat_intigua_exists = src_exists("/usr/share/intigua/tomcat")

    if not intigua_exists:
        raise Exception("Intigua not installed!")

    if tomcat_intigua_exists:
        return ["intigua"]
    if tocmat_exists and nginx_exists:
        return ["tomcat","nginx"]

    raise Exception("Tomcat or Nginx are not installed!")

def test_ssh(host):
    if 0 != Ssh(host, quite=True).run(["uptime"]):
        raise Exception("Can't ssh to " + host)
